#EzProtection by MiB
import es
import gamethread
import playerlib
import langlib
import cfglib
from . import ex
from os.path import join
try:
    import spe
    es.dbgmsg(0,"-EzProtection- Source Python Extentions found, using SPE for certain functions.")
    isSPE = True
except ImportError:
    es.dbgmsg(0,"-EzProtection- Source Python Extentions not found, using ES for certain functions.")
    isSPE = False

_info = es.AddonInfo()
_info["name"] = "EzProtection"
_info["basename"] = "ezprotection"
_info["version"] = "0.1"
_info["authors"] = "MiB"
_info["url"] = "http://www.sddcommunity.com"
_info["description"] = "EzProtection is a great and easily configurable spawn protection."
_gamedir = str(es.ServerVar("eventscripts_gamedir"))
_mapfilter = ex.readfile(join(_gamedir,"cfg/eventscripts/ezprotection/mapfilter.txt"))
_weaponfilter = ex.readfile(join(_gamedir,"cfg/eventscripts/ezprotection/weaponfilter.txt"))
_map = es.ServerVar("eventscripts_currentmap")
_lang = langlib.Strings(_gamedir + "/cfg/eventscripts/ezprotection/strings.ini")
_cfg = cfglib.AddonCFG(join(_gamedir,"cfg/eventscripts/ezprotection/config.cfg"))
_cfg.text("This is the config file for EzProtection v" + _info["version"] + ".")
_cfg.text("If information about the mod is needed please goto addons.eventscripts.com/addons/view/" + _info["basename"] + ".")
_cfg.text(" ")
_cfg.text(" ")
_cfg.text("-General Settings-")
_cfg.text("Heres where the general settings for EzProtection will be.")
_cfg.text(" ")
_roundmsg = _cfg.cvar("ez_pro_roundmsg",1,"Should EzProtection message on round start that spawn protection is active?")
_tell = _cfg.cvar("ez_pro_tell",1,"Should EzProtection display the protection timer to players?")
_time = _cfg.cvar("ez_pro_time",3,"How long should spawn protection last?")
_type = _cfg.cvar("ez_pro_type","spawn","When should spawn protection occur? (spawn/round start)")
_botblock = _cfg.cvar("ez_pro_bot_block",0,"Should EzProtection block bots from recieving protection? (Note: Not working in this version, expect it to work in next version.)")
_cfg.text(" ")
_cfg.text(" ")
_cfg.text("-Protection Settings-")
_cfg.text("Heres where the spawn protection settings for EzProtection will be.")
_cfg.text(" ")
_god = _cfg.cvar("ez_pro_god_mode",1,"Should spawn protection include god mode?")
_noblock = _cfg.cvar("ez_pro_noblock",0,"Should spawn protection include noblock?")
_hurtback = _cfg.cvar("ez_pro_hurt_back",0,"Should spawn protection include hurting back the attacker?")
_giveback = _cfg.cvar("ez_pro_give_back",0,"Should spawn protection include giving back the damage the protected took as health to the protected?")
_sethealth = _cfg.cvar("ez_pro_set_health",0,"Should spawn protection include setting health?")
_sethealth_setting = _cfg.cvar("ez_pro_set_health_setting",5000,"If so what health should the player be set to during protection?")
_sethealth_rsetting = _cfg.cvar("ez_pro_set_health_rsetting","#health","If so what health setting should the player be set back to after spawn protection is over? \n// (use the setting '#health' if you want it to be the player's original health / or use the setting #leave to make it not reset the player's health)")
_cfg.write()

#Thanks to Absolute!
class Players(dict):
    def __init__(self, fixed_type=str, *args, **kwargs):
        self._fixed_type = fixed_type
        dict.__init__(self, *args, **kwargs)
       
    def __setitem__(self, key, value):
        dict.__setitem__(self, self._fixed_type(key), value)
       
    def __getitem__(self, key):
        return dict.__getitem__(self, self._fixed_type(key))
       
    def __contains__(self, key):
        return dict.__contains__(self, self._fixed_type(key))
       
    def __delitem__(self, key):
        dict.__delitem__(self, self._fixed_type(key))

players = Players(str)

class spawnpro():
    def __init__(self,userid):
        self.userid = userid
        self.player = playerlib.getPlayer(userid)

    def start(self):
        if not self.userid in players:
            return
        players[self.userid]["count"] += 1
        players[self.userid]["ohp"] = self.player.health
        self.timer(int(_time),players[self.userid]["count"])

    def timer(self,time,count):
        if not self.userid in players or self.player.isdead:
            return
        if count != players[self.userid]["count"]:
            return
        if _tell:
            lang_tell(self.userid,"protectiontime",{"ptime":time},style="center")
        if time:
            if _god:
                self.player.godmode = 1
            if _noblock:
                self.player.noblock = 1
            if _hurtback:
                players[self.userid]["hurtback"] = 1
            if _giveback:
                players[self.userid]["giveback"] = 1
            if _sethealth:
                self.player.health = _sethealth_setting
            time -= 1
            gamethread.delayedname(1,"spawnprotection",self.timer,(time,count))
        else:
            if _god:
                self.player.godmode = 0
            if _noblock:
                self.player.noblock = 0
            if _hurtback:
                players[self.userid]["hurtback"] = 0
            if _giveback:
                players[self.userid]["giveback"] = 0
            if _sethealth:
                if _sethealth_rsetting == "#health":
                    self.player.health = players[self.userid]["ohp"]
                elif _sethealth_rsetting == "#leave":
                    pass
                else:
                    self.player.health = _sethealth_rsetting

def lang_msg(langval,langtok,style="tell"):
    for userid in players:
        language = playerlib.getPlayer(userid).get("lang")
        if style == "tell":
            es.tell(userid,"#multi",_lang("tag",{},"special") + _lang(langval,langtok,language))
        else:
            es.centertell(userid,_lang(langval,langtok,language))

def lang_tell(userid,langval,langtok,style="tell"):
    language = playerlib.getPlayer(userid).get("lang")
    if style == "tell":
        es.tell(userid,"#multi",_lang("tag",{},"special") + _lang(langval,langtok,language))
    else:
        es.centertell(userid,_lang(langval,langtok,language))

def load():
    if isSPE:
        spe.registerPreHook("player_hurt",_player_hurt)
    else:
        _self = __import__(__name__)
        es.addons.registerForEvent(_self,"_player_hurt",player_hurt)
    _cfg.execute()
    es.dbgmsg(0,"-EzProtection- Finished loading.")
    es.ServerVar("ez_pro_version",_info["version"],"What version is EzProtection?").makepublic()

def unload():
    if isSPE:
        spe.unregisterPreHook("player_hurt",_player_hurt)
    else:
        es.addons.unregisterForEvent("_player_hurt",player_hurt)
    es.dbgmsg(0,"-EzProtection- Finished unloading.")

def round_end(ev):
    gamethread.cancelDelayed("spawnprotection")

def round_start(ev):
    if str(_map) in _mapfilter:
        return
    lang_msg("roundmessage",{"setting":_type})
    if _type == "round start":
        for userid in players:
            if not playerlib.getPlayer(userid).isdead:
                spawnpro(userid).start()

def _player_hurt(ev):
    if str(_map) in _mapfilter:
        return
    if ev["weapon"] in _weaponfilter or not ev["userid"] in players:
        return
    if _hurtback:
        if players[ev["userid"]]["hurtback"] == 1 and playerlib.getPlayer(ev["attacker"]).health != 0:
            ex.damage(ev["userid"],ev["attacker"],ev["dmg_health"])
            lang_tell(ev["attacker"],"hurtback",{"damage":ev["dmg_health"]})
    if _giveback:
        if players[ev["userid"]]["giveback"] == 1:
            playerlib.getPlayer(ev["userid"]).health += ev["dmg_health"]
            lang_tell(ev["userid"],"giveback",{"damage":ev["dmg_health"]})
    
def player_spawn(ev):
    if not ev["userid"] in players:
        players[ev["userid"]] = {}
        players[ev["userid"]]["count"] = 0
        players[ev["userid"]]["ohp"] = 0
        players[ev["userid"]]["giveback"] = 0
        players[ev["userid"]]["hurtback"] = 0
    if str(_map) in _mapfilter:
        return
    if _type == "spawn":
        if not playerlib.getPlayer(ev["userid"]).isdead:
            spawnpro(ev["userid"]).start()

def player_disconnect(ev):
    if ev["userid"] in players:
        del players[ev["userid"]]
